/*** build a browse ***/
/*** MODULE INFORMATION ****
*SYSTEM   General System
*CRTBY    chris tam
*CRTDATE  05/06/95
*VERSION  1.0
**** MODULE INFORMATION ***/
#include "common.ch"
#include "inkey.ch"
#include "setcurs.ch"

#define SP4 space(4)

static browInfo
#define DBASE   1
#define INDEX   2
#define TOP     3
#define LEFT    4
#define BOTTOM  5
#define RIGHT   6
#define HEAD    7 
#define OTHERIDX 8

static genIni

static aKey

static cProc

static cFilter

static othIdx

procedure vs(cFile)
	setup()
	
	DEFAULT cFile TO 'TAMBROW'

	Loadcfg(cFile)

	if !used()
		if LoadData() == false
			return
		endif
	endif

	mainBrow(cFile)

	cleanup()
return

static procedure setup
	set scoreboard off
	set date format to "DD/MM/YY"

	TM_NVbackgd()
	TM_NVtitle('COMPANY','GENERATE BROWSE')
	@ 24,0 say 'F10=Menu'

	browInfo := {'','',5,0,23,79,'Data Base'}
	aKey := {}
	cProc := ""
	othIdx := {}

return

static procedure cleanup
	dbcloseall()
return

static procedure LoadCfg(cFile)
	local i
	local dotpos,tempname
	local tmpLn

	if file(cFile+'.zzz')
		genIni := TM_fileasarray(cFile+'.zzz')
		i:=1
		do while true
			if alltrim(genIni[i]) == '[BROWSE DESKTOP]'
				exit
			else
				i++
			endif
		end
		browInfo[DBASE] := alltrim(genIni[i+DBASE])
		browInfo[INDEX] := alltrim(genIni[i+INDEX])
		browInfo[TOP] := val(genIni[i+TOP])
		browInfo[LEFT] := val(genIni[i+LEFT])
		browInfo[BOTTOM] := val(genIni[i+BOTTOM])
		browInfo[RIGHT] := val(genIni[i+RIGHT])
		browInfo[HEAD] := alltrim(genIni[i+HEAD])
		
		tmpLn := alltrim(genIni[i+OTHERIDX])
		if !empty(tmpLn)
			othidx := listasarray(tmpLn,',')
		endif

		dotpos := at('.',browInfo[DBASE])
		tempname := substr(browinfo[DBASE],1,dotpos-1)      
		use &(tempname) new shared
		dotpos := at('.',browInfo[INDEX])
		tempname := substr(browinfo[INDEX],1,dotpos-1)
		set index to &(tempname)


	else
		genIni := {}
	endif

return

static function LoadData
	local DirInfo := directory("*.dbf")
	local aDBF,aNtx
	local i
	local nChoi
	local nTotFld := fcount()
	local dotpos

	if empty(DirInfo)
		return false
	endif

	aDBF := {}
	for i:=1 to len(DirInfo)
		aadd(aDBF,DirInfo[i,1])
	next
	asort(aDBF)
	nchoi := TM_menu(5,0,15,30,aDBF,'Select Database')
	if nchoi > 0
		use &(aDBF[nchoi]) new shared alias "dataDB"
	else
		return false
	endif   

	browInfo[DBASE] := aDBF[nchoi]
	browInfo[HEAD] := aDBF[nchoi]

	dirinfo := directory("*.NTX")
	aNtx := {}  
	for i:=1 to len(dirinfo)
		aadd(aNtx,dirinfo[i,1])
	next
	asort(aNtx) 
	nchoi := TM_menu(5,0,15,30,aNtx,'Select Main Index')
	if nchoi > 0
		set index to &(aNtx[nchoi])
	endif

	browInfo[INDEX] := aNtx[nchoi]

	do while true
		nchoi := TM_menu(5,0,15,30,aNtx,'Select Other Index')
		if lastkey() == K_ESC
			exit
		else
			if nchoi > 0
				dotpos := at('.',aNtx[nchoi])
				aadd(othIdx,substr(aNtx[nchoi],1,dotpos-1))
			endif
		endif
	end

return true

static procedure mainBrow(cFile)
	local oTB,i,oCol

	oTB := TM_browse(browInfo[TOP],browInfo[LEFT],browInfo[BOTTOM],browInfo[RIGHT])
	TM_addkey(K_F10,{|oTB|editTB(oTB,cFile)})
	
	if file(cFile+'.ZZZ')
		readInCol(cFile,oTB)
	else
		TM_browFld(oTB)
		for i:=1 to oTB:colCount
			oCol := oTB:getcolumn(i)
			oCol:cargo := oCol:heading      
		next
	endif

	if file(cFile+'.ZZZ')
		readInKey(cFile)
	endif

	if file(cFile+'.FUN')
		cProc := memoread(cFile+'.FUN')
	endif

	TM_browRun(oTB,browInfo[TOP],browInfo[LEFT],browInfo[BOTTOM],browInfo[RIGHT],browInfo[HEAD])

return

static procedure readInCol(cFile,oTB)
	local i
	local oCol
	local cHead
	local cFld
	local nWid
	local spos,epos

	i:=1
	spos := 0
	epos := 0
	do while true
		if genIni[i] == '[COLUMN INFO]'
			spos := i
			i++
		else
			if spos > 0 .and. substr(alltrim(genIni[i]),1,1)=='['
				epos := i
				exit
			else
				i++
			endif
		endif
	enddo
	for i:= spos+1 to epos-1
		cHead := alltrim(substr(genIni[i],1,50))
		cFld := alltrim(substr(genIni[i],51,10))
		nWid := val(substr(genIni[i],61,len(genIni[i])-60))
		IF !empty(cHead) .and. !empty(cFld)
			oCol := TBColumnNew(cHead,FieldBlock(cFld))
			oCol:cargo := cFld
			if nWid > -1
				oCol:width := nWid
			endif
			oTB:addcolumn(oCol)
		endif
	next
return

static procedure readInKey(cFile)
	local cK,cActBlk
	local i
	local spos,epos

	i:=1
	spos := 0
	epos := 0
	do while true
		if genIni[i] == '[KEY]'
			spos := i
			i++
		else
			if spos > 0 .and. substr(alltrim(genIni[i]),1,1)=='['
				epos := i
				exit
			else
				i++
			endif
		endif
	enddo

	if epos - spos > 1
		for i:= spos+1 to epos-1
			cK := substr(genIni[i],1,10)
			cActBlk := substr(genIni[i],11,len(genIni[i])-10)
			IF !empty(cK) .and. !empty(cActBlk)
				aadd(akey,{cK,cActBlk})     
			endif
		next
	endif

return

static procedure editTB(oTB,cFile)
	local opt := {"Edit Browse Information","Edit Column Information", ;
					"Insert Column","Delete Column","Add Key Action", ;
					"Generate Code","Save Config" }
	local nchoi

	nchoi := TM_menu(5,0,15,30,opt,'Select')
	do case
		case nchoi == 1
			editBrow(oTB)
		case nchoi == 2
			editCol(oTB)
		case nchoi == 3
			insCol(oTB)
		case nchoi == 4
			delCol(oTB)
		case nchoi == 5
			addBKey(oTB)
		case nchoi == 6
			GenCode(oTB)
		case nchoi == 7
			SaveCfg(oTB,cFile)
		case nchoi == 8
//            EditProc(oTB)
		otherwise
			freshborder()
			oTB:refreshall()
	end case

return

static procedure editBrow(oTB)
	local getlist := {}
	local cTitle := padr(browInfo[HEAD],50)

	@ 5,0 clear to 23,79
	@ 5,0 say 'Top    :' get browInfo[TOP]
	@ 6,0 say 'left   :' get browInfo[LEFT]
	@ 7,0 say 'bottom :' get browInfo[BOTTOM]
	@ 8,0 say 'right  :' get browInfo[RIGHT]
	@ 9,0 say 'Title  :' get cTitle
	read

	@ 5,0 clear to 23,79
	oTB:ntop := browInfo[TOP]+1
	oTB:nleft := browInfo[LEFT]+1
	oTB:nbottom := browInfo[BOTTOM]-1
	oTB:nright := browInfo[RIGHT]-1
	browInfo[HEAD] := alltrim(cTitle)
	freshBorder()
	oTB:refreshall()
return

static procedure editCol(oTB)
	local colpos := oTB:colpos
	local oCol := oTB:getcolumn(colpos)
	local cColHead := padr(oCol:heading,30)
	local nColWidth := oCol:width
	local cFldVal 
	local getlist := {}

	if empty(nColwidth)
		cFldval := eval(oCol:block)
		do case
			case ischaracter(cFldval)
				nColwidth := len(cFldval)
			case isnumber(cFldval)
				nColwidth := 10
			case islogical(cFldVal)
				nColwidth := 3
			case isdate(cFldval)
				nColwidth := 8
		end case
	endif

	@ 5,0 clear to 23,79
	@ 5,0 say 'Heading :' get cColHead
	@ 6,0 say 'Width   :' get nColWidth
	read
	@ 5,0 clear to 23,79

	oCol:heading := alltrim(cColHead)
	oCol:width := nColWidth
	oTB:setcolumn(colpos,oCol)
	freshBorder()
	oTB:refreshall()
return

static procedure delCol(oTB)
	local colpos := oTB:colpos
	
	oTB:delcolumn(colpos)
	freshBorder()
	oTB:refreshall()
return

static procedure insCol(oTB)
	local colpos := oTB:colpos
	local nTotFld := fcount()
	local aFldName := {}
	local i,nchoi
	local oCol

	for i:=1 to nTotFld
		aadd(aFldName,fieldname(i))
	next

	@ 5,0 clear to 23,79
	nchoi := TM_menu(5,0,20,30,aFldName,'Select Field')
	@ 5,0 clear to 23,79
	if nchoi > 0
		oCol := TBColumnNew(aFldName[nchoi],fieldblock(aFldname[nchoi]))
		oCol:cargo := aFldName[nchoi]
		oTB:inscolumn(colpos,oCol)
	endif   
	
	freshBorder()
	oTB:refreshall()

return

static procedure addBkey(oTB)
	local nKey := space(10)
	local cAct := padr('DoAct(oTB)',50)
	local getlist := {}
	local npos

	@ 5,0 clear to 23,79
	@ 5,0 say 'Key for action :' get nKey picture "@!"
	@ 7,0 say 'Do :' get cAct when whKey(nKey)            
	read    

	if !empty(nkey) .and. !empty(cAct)
		npos := ascan(akey,{|x|x[1]==nkey})
		if npos > 0
			aKey[npos] := {nKey,alltrim(cAct),""}
		else
			aadd(akey,{nKey,alltrim(cAct),""})
		endif
	endif

	@ 5,0 clear to 23,79
	freshBorder()
	oTB:refreshall()
return

static function whKey(nKey)
	local npos 
	local oget := getactive()

	if !empty(aKey)
		npos := ascan(aKey,{|x|x[1]==nKey})
		if npos > 0
			oget:varput(padr(aKey[npos,2],50))  
		endif
	endif
return true

static procedure freshBorder
	@ browInfo[TOP],browInfo[LEFT] to browInfo[BOTTOM],browInfo[RIGHT] double
	@ browInfo[TOP],browInfo[LEFT]+1 say '['+browInfo[HEAD]+']'
return

static procedure Gencode(oTB)
	local cOutName := padr('Browse',8)
	local lOpenDB := false
	local lNovell := false
	local cLtd := space(50)
	local cSys := space(50)
	local lSaveScr := false
	local lFilter := false
	local getlist := {}
	local nhandle 
	local i,prgname
	local lok

	@ 5,0 clear to 23,79
	@ 5,0 say 'Filename for generate code :' get cOutName picture "@!"
	@ 6,0 say 'Open Database              :' get lOpenDB
	@ 7,0 say 'Novell style background    :' get lNovell
	@ 8,0 say 'Company name               :' get cLtd when lNovell
	@ 9,0 say 'System name                :' get cSys when lNovell
	@ 10,0 say 'Filter Data                :' get lFilter
	@ 11,0 say 'Save / Restore Screen      :' get lSaveScr
	read
	cOutName := alltrim(cOutName)
	
	if !empty(cOutName)
		if file(cOutName+'.PRG')
			prgname := cOutname
			cOutname += '.PRG'
			nhandle := fcreate('$$$ZZZ$$.$$$')
			lok := true
		else
			cOutName += '.PRG'
			nhandle := fcreate(cOutName)
			lok := false
		endif
		if lFilter 
			wrtComment(nhandle)
			wrtHeader(nhandle)
			fwrite(nhandle,'/*** $$$ZZZ1 ***/'+CRLF)
			wrtFMain(nhandle,oTB,cOutname,lOpenDB,lNovell,cLtd,cSys,lSaveScr)
			wrtNext(nhandle)
			fwrite(nhandle,'/*** $$$ZZZ2 ***/'+CRLF)
		else
			wrtComment(nhandle)     
			wrtHeader(nhandle)      
			fwrite(nhandle,'/*** $$$ZZZ1 ***/'+CRLF)
			wrtMain(nhandle,oTB,cOutname,lOpenDB,lNovell,cLtd,cSys,lSaveScr)
			wrtStd(nhandle)
			fwrite(nhandle,'/*** $$$ZZZ2 ***/'+CRLF)
		endif
		fwrite(nhandle,cProc+CRLF)  

		fclose(nhandle)
		
		if lok == true
			if alert("Output File already exist",{"Overwrite Prg","Del and Ins Code"}) == 1
				i := 1
				do while true
					if !file(prgName+'.'+padl(alltrim(str(i)),3,'0'))
						exit
					else
						i++
					endif
				end
				frename(prgName+'.PRG',prgName+'.'+padl(alltrim(str(i)),3,'0'))
				frename('$$$ZZZ$$.$$$',prgName+'.PRG')
			else
				ReplacePrg(prgname)
				ferase('$$$ZZZ$$.$$$')
			endif
		endif
	endif

	freshborder()
	oTB:refreshall()
return

static procedure ReplacePrg(prgname)
	local cBuff := memoread('$$$ZZZ$$.$$$')
	local spos,epos,cRepStr

	spos := at('/*** $$$ZZZ1 ***/',cBuff)
	epos := at('/*** $$$ZZZ2 ***/',cBuff)

	cRepStr := substr(cBuff,spos,epos-spos+17)

	cBuff := memoread(prgname+'.PRG')
	spos := at('/*** $$$ZZZ1 ***/',cBuff)
	epos := at('/*** $$$ZZZ2 ***/',cBuff)
	cBuff := stuff(cBuff,spos,epos-spos+17,cRepStr)
	memowrit(prgname+'.PRG',cBuff)

return

static procedure wrtStd(nhandle)
	local i

	fwrite(nhandle,'static function stdSkipper(skipCnt)'+CRLF)    
	fwrite(nhandle,SP4+'local nMoved := 0'+CRLF)
	fwrite(nhandle,CRLF)
	fwrite(nhandle,SP4+'if skipcnt == 0 .or. lastrec() == 0'+CRLF)
	fwrite(nhandle,SP4+SP4+'dbskip(0)'+CRLF)
	fwrite(nhandle,SP4+'elseif skipcnt > 0 .and. recno() != lastrec() + 1'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while nMoved < skipcnt'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'if eof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+SP4+'dbskip(-1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+SP4+'exit'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'nMoved++'+CRLF)
	fwrite(nhandle,SP4+SP4+'end do'+CRLF)
	fwrite(nhandle,SP4+'elseif skipcnt < 0'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while nMoved > skipcnt'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(-1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'if bof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+SP4+'exit'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'nMoved--'+CRLF)
	fwrite(nhandle,SP4+SP4+'end do'+CRLF)
	fwrite(nhandle,SP4+'endif'+CRLF)
	fwrite(nhandle,'return nMoved'+CRLF)

	fwrite(nhandle,'static function appKey(nKey,oTB)'+CRLF)
	fwrite(nhandle,SP4+'do case'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_UP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:up()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_DOWN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:down()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_LEFT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:left()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_RIGHT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:right()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_PGUP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:pageup()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_PGDN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:pagedown()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_PGDN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:goBottom()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_PGUP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:goTop()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_HOME'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:home()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_END'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:end()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_HOME'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panHome()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_END'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panEnd()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_LEFT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panLeft()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_RIGHT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panRight()'+CRLF)
	
	for i:=1 to len(aKey)
		fwrite(nhandle,SP4+SP4+'case nKey == '+alltrim(aKey[i,1])+CRLF)
		fwrite(nhandle,SP4+SP4+SP4+alltrim(aKey[i,2])+CRLF)
	next    

	fwrite(nhandle,SP4+'end case'+CRLF)
	fwrite(nhandle,'return true'+CRLF)

return

static procedure wrtNext(nhandle)
	local i

	fwrite(nhandle,'static function nextkey(xvalue)'+CRLF)
	fwrite(nhandle,SP4+'local cType := valtype(xvalue)'+CRLF)
	fwrite(nhandle,SP4+'local xNext'+CRLF)
	fwrite(nhandle,CRLF)
	fwrite(nhandle,SP4+'do case'+CRLF)
	fwrite(nhandle,SP4+SP4+'case cType == "C"'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'xNext := stuff(xvalue,len(xvalue),1, ;'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'  CHR(asc(right(xvalue,1))+1))'+CRLF)
	fwrite(nhandle,SP4+SP4+'case cType == "N"'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'xNext := xvalue+1'+CRLF)
	fwrite(nhandle,SP4+SP4+'case cType == "D"'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'xNext := xvalue+1'+CRLF)
	fwrite(nhandle,SP4+SP4+'otherwise'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'xNext := xvalue'+CRLF)
	fwrite(nhandle,SP4+'end case'+CRLF)
	fwrite(nhandle,'return xnext'+CRLF)
	fwrite(nhandle,CRLF)

	fwrite(nhandle,'static function gilligan(skipcnt, hival, lowval)'+CRLF)
	fwrite(nhandle,SP4+'local Movement := 0'+CRLF)
	fwrite(nhandle,CRLF)
	fwrite(nhandle,SP4+'Do case'+CRLF)
	fwrite(nhandle,SP4+SP4+'case skipcnt == 0'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(0)'+CRLF)
	fwrite(nhandle,SP4+SP4+'case skipcnt > 0'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while Movement < skipcnt .and. &(indexkey(0)) <= lowval .and. !eof() '+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'Movement++'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while ( &(indexkey(0)) > lowval .or. eof() ) .and. !bof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(-1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'Movement--'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'if bof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'keyboard chr(K_ESC)'+CRLF)
	fwrite(nhandle,SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+'case skipcnt < 0'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while Movement > skipcnt .and. &(indexkey(0)) >= hival'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'dbskip(-1)'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'if bof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+SP4+'exit'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'Movement--'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while &(indexkey(0)) < hival .and. !eof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'skip'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'Movement++'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'if eof()'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'keyboard chr(K_ESC)'+CRLF)
	fwrite(nhandle,SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+'end case'+CRLF)
	fwrite(nhandle,'return Movement'+CRLF)
	fwrite(nhandle,CRLF)

	fwrite(nhandle,'static function appKey(nKey,oTB)'+CRLF)
	fwrite(nhandle,SP4+'do case'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_UP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:up()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_DOWN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:down()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_LEFT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:left()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_RIGHT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:right()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_PGUP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:pageup()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_PGDN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:pagedown()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_PGDN'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:goBottom()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_PGUP'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:goTop()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_HOME'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:home()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_END'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:end()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_HOME'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panHome()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_END'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panEnd()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_LEFT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panLeft()'+CRLF)
	fwrite(nhandle,SP4+SP4+'case nKey == K_CTRL_RIGHT'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'oTB:panRight()'+CRLF)
	
	for i:=1 to len(aKey)
		fwrite(nhandle,SP4+SP4+'case nKey == '+alltrim(aKey[i,1])+CRLF)
		fwrite(nhandle,SP4+SP4+SP4+alltrim(aKey[i,2])+CRLF)
	next    

	fwrite(nhandle,SP4+'end case'+CRLF)
	fwrite(nhandle,'return true'+CRLF)
return

static procedure wrtcomment(nhandle)
	fwrite(nhandle,'/* Browse Database '+browInfo[DBASE]+' */'+CRLF)
	fwrite(nhandle,'/*** MODULE INFORMATION ****'+CRLF)
	fwrite(nhandle,'*SYSTEM   BROWSE SYSTEM'+CRLF)
	fwrite(nhandle,'*CRTBY    chris tam'+CRLF)
	fwrite(nhandle,'*CRTDATE  '+dtoc(date())+CRLF)
	fwrite(nhandle,'*VERSION  1.0'+CRLF)
	fwrite(nhandle,'**** MODULE INFORMATION ***/'+CRLF)
	fwrite(nhandle,CRLF)
return

static procedure wrtHeader(nhandle)
	fwrite(nhandle,'#include "common.ch"'+CRLF)
	fwrite(nhandle,'#include "inkey.ch"'+CRLF)
	fwrite(nhandle,'#include "setcurs.ch"'+CRLF)
	fwrite(nhandle,CRLF)
return

static procedure wrtMain(nhandle,oTB,outName,lOpenDB,lNovell,cLtd,cSys,lsavescr)
	local cDBname,cIdxName
	local dotpos
	local i
	local oCol

	dotpos := at('.',outname)
	fwrite(nhandle,'procedure '+substr(outname,1,dotpos-1)+CRLF)
	fwrite(nhandle,'   local oTB'+CRLF)
	fwrite(nhandle,'   local nKey'+CRLF)
	fwrite(nhandle,'   local oCol'+CRLF)
	fwrite(nhandle,'   local oldscr,oldcur,oldscore,oldexact'+CRLF)
	fwrite(nhandle,CRLF)
	
	fwrite(nhandle,SP4+'oldscore := set(_SET_SCOREBOARD,false)'+CRLF)
	fwrite(nhandle,SP4+'oldcur := setcursor(SC_NONE)'+CRLF)
	fwrite(nhandle,SP4+'oldexact := set(_SET_EXACT,false)'+CRLF)
	if lsavescr
		fwrite(nhandle,SP4+'oldscr := savescreen('+alltrim(str(browInfo[TOP]))+','+ ;
											   alltrim(str(browInfo[LEFT]))+','+ ;
											   alltrim(str(browInfo[BOTTOM]))+','+ ;
											   alltrim(str(browInfo[RIGHT]))+')'+CRLF)
	endif
	fwrite(nhandle,CRLF)

	if lOpenDB
		dotpos := at('.',browInfo[DBASE])
		cDBname := substr(browinfo[DBASE],1,dotpos-1)
		dotpos := at('.',browinfo[INDEX])
		cIdxname := substr(browinfo[INDEX],1,dotpos-1)      

		fwrite(nhandle,SP4+'use '+cDBname+' new shared'+CRLF)
		fwrite(nhandle,SP4+'set index to '+cIdxName)
		if empty(othIdx)
			fwrite(nhandle,+CRLF)
		else
			for i:=1 to len(othIdx)
				if i < len(othIdx)
					fwrite(nhandle,','+alltrim(othIdx[i]))
				else
					fwrite(nhandle,','+alltrim(othIdx[i])+CRLF)
				endif
			next
		endif
		fwrite(nhandle,CRLF)
	else
		fwrite(nhandle,SP4+'// database is opened in main program'+CRLF)    
		fwrite(nhandle,CRLF)
	endif

	if lNovell
		fwrite(nhandle,SP4+'dispbox(0,0,24,79,"")'+CRLF)
		fwrite(nhandle,SP4+'@ 0,0 to 3,79 color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 1,1 say padc("'+alltrim(cLtd)+'",78) color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 2,1 say padr("'+alltrim(cSys)+'",71) color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 2,71 say date() color "N/W"'+CRLF)
		fwrite(nhandle,CRLF)
	endif   

	fwrite(nhandle,SP4+'oTB := TbrowseDB('+alltrim(str(browInfo[TOP]))+'+1,'+ ;
										alltrim(str(browInfo[LEFT]))+'+1,'+ ;
										alltrim(str(browInfo[BOTTOM]))+'-1,'+ ;
										alltrim(str(browInfo[RIGHT]))+'-1)'+CRLF)
	fwrite(nhandle,SP4+'oTB:headSep := ""'+CRLF)
	fwrite(nhandle,SP4+'oTB:colSep  := "  "'+CRLF)
	fwrite(nhandle,SP4+'oTB:gotopblock := {||dbgotop()}'+CRLF)
	fwrite(nhandle,SP4+'oTB:gobottomBlock := {||dbgobottom()}'+CRLF)
	fwrite(nhandle,SP4+'oTB:skipBlock := {|skipcnt|stdSkipper(skipcnt)}'+CRLF)

	for i:=1 to oTB:colcount
		oCol := oTB:getcolumn(i)
		fwrite(nhandle,SP4+'oCol := TBcolumnNew("'+oCol:heading+'",fieldblock("'+oCol:cargo+'"))'+CRLF)
		fwrite(nhandle,SP4+'oTB:addcolumn(oCol)'+CRLF)
	next
	fwrite(nhandle,CRLF)

	fwrite(nhandle,SP4+'@ '+alltrim(str(browInfo[TOP]))+','+ ;
									alltrim(str(browInfo[LEFT]))+' to '+ ;
									alltrim(str(browInfo[BOTTOM]))+','+ ;
									alltrim(str(browInfo[RIGHT]))+' DOUBLE '+CRLF)
	fwrite(nhandle,SP4+'@ '+alltrim(str(browInfo[TOP]))+','+ ;
							alltrim(str(browInfo[LEFT]))+'+1 SAY "['+ ;
							alltrim(browInfo[HEAD])+']"'+CRLF)
	fwrite(nhandle,CRLF)

	fwrite(nhandle,SP4+'oTB:gotop()'+CRLF)
	fwrite(nhandle,CRLF)
	
	fwrite(nhandle,SP4+'do while !(nKey==K_ESC)'+CRLF)
	fwrite(nhandle,SP4+SP4+'dispbegin()'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while (nKey := inkey()) == 0 .and. !oTB:stabilize()'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'dispend()'+CRLF)
	fwrite(nhandle,SP4+SP4+'if oTB:stable'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'nkey := inkey(0)'+CRLF)
	fwrite(nhandle,SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+'appKey(nKey,oTB)'+CRLF)
	fwrite(nhandle,SP4+'enddo'+CRLF)
							

	if lOpenDB
		fwrite(nhandle,SP4+'use '+CRLF)
		fwrite(nhandle,CRLF)
	else
		fwrite(nhandle,SP4+'// database is close in main program'+CRLF) 
	endif

	fwrite(nhandle,SP4+'set(_SET_SCOREBOARD,oldscore)'+CRLF)
	fwrite(nhandle,SP4+'setcursor(oldcur)'+CRLF)
	fwrite(nhandle,SP4+'set(_SET_EXACT,oldexact)'+CRLF)
	if lsavescr
		fwrite(nhandle,SP4+'restscreen('+alltrim(str(browInfo[TOP]))+','+ ;
									 alltrim(str(browInfo[LEFT]))+','+ ;
									 alltrim(str(browInfo[BOTTOM]))+','+ ;
									 alltrim(str(browInfo[RIGHT]))+',oldscr)'+CRLF)
	endif

	fwrite(nhandle,'return'+CRLF)
	fwrite(nhandle,CRLF)

return

static procedure wrtFMain(nhandle,oTB,outName,lOpenDB,lNovell,cLtd,cSys,lSaveScr)
	local cDBname,cIdxName
	local dotpos
	local i
	local oCol

	dotpos := at('.',outname)
	fwrite(nhandle,'procedure '+substr(outname,1,dotpos-1)+'(hival,lowval)'+CRLF)
	fwrite(nhandle,'   local oTB'+CRLF)
	fwrite(nhandle,'   local nKey'+CRLF)
	fwrite(nhandle,'   local seekval := nextkey(hival)'+CRLF)
	fwrite(nhandle,'   local oCol'+CRLF)
	fwrite(nhandle,'   local oldscr,oldcur,oldscore,oldexact'+CRLF)
	fwrite(nhandle,CRLF)
	
	fwrite(nhandle,SP4+'DEFAULT lowval TO hival'+CRLF)
	fwrite(nhandle,SP4+'oldscore := set(_SET_SCOREBOARD,false)'+CRLF)
	fwrite(nhandle,SP4+'oldcur := setcursor(SC_NONE)'+CRLF)
	fwrite(nhandle,SP4+'oldexact := set(_SET_EXACT,false)'+CRLF)
	if lsavescr
		fwrite(nhandle,SP4+'oldscr := savescreen('+alltrim(str(browInfo[TOP]))+','+ ;
											   alltrim(str(browInfo[LEFT]))+','+ ;
											   alltrim(str(browInfo[BOTTOM]))+','+ ;
											   alltrim(str(browInfo[RIGHT]))+')'+CRLF)
	endif
	fwrite(nhandle,CRLF)

	if lOpenDB
		dotpos := at('.',browInfo[DBASE])
		cDBname := substr(browinfo[DBASE],1,dotpos-1)
		dotpos := at('.',browinfo[INDEX])
		cIdxname := substr(browinfo[INDEX],1,dotpos-1)      

		fwrite(nhandle,SP4+'use '+cDBname+' new shared'+CRLF)
		fwrite(nhandle,SP4+'set index to '+cIdxName)
		if empty(othIdx)
			fwrite(nhandle,+CRLF)
		else
			for i:=1 to len(othIdx)
				if i < len(othIdx)
					fwrite(nhandle,','+alltrim(othIdx[i]))
				else
					fwrite(nhandle,','+alltrim(othIdx[i])+CRLF)
				endif
			next
		endif
		fwrite(nhandle,CRLF)
	else
		fwrite(nhandle,SP4+'// database is opened in main program'+CRLF)    
		fwrite(nhandle,CRLF)
	endif

	if lNovell
		fwrite(nhandle,SP4+'dispbox(0,0,24,79,"")'+CRLF)
		fwrite(nhandle,SP4+'@ 0,0 to 3,79 color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 1,1 say padc("'+alltrim(cLtd)+'",78) color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 2,1 say padr("'+alltrim(cSys)+'",71) color "N/W"'+CRLF)
		fwrite(nhandle,SP4+'@ 2,71 say date() color "N/W"'+CRLF)
		fwrite(nhandle,CRLF)
	endif   

	fwrite(nhandle,SP4+'oTB := TbrowseDB('+alltrim(str(browInfo[TOP]))+'+1,'+ ;
										alltrim(str(browInfo[LEFT]))+'+1,'+ ;
										alltrim(str(browInfo[BOTTOM]))+'-1,'+ ;
										alltrim(str(browInfo[RIGHT]))+'-1)'+CRLF)
	fwrite(nhandle,SP4+'oTB:headSep := ""'+CRLF)
	fwrite(nhandle,SP4+'oTB:colSep  := "  "'+CRLF)
	fwrite(nhandle,SP4+'oTB:gotopblock := {||dbseek(hival,true)}'+CRLF)
	fwrite(nhandle,SP4+'oTB:gobottomBlock := {||dbseek(seekval,true),dbskip(-1)}'+CRLF)
	fwrite(nhandle,SP4+'oTB:skipBlock := {|skipcnt|Gilligan(skipcnt,hival,lowval)}'+CRLF)

	for i:=1 to oTB:colcount
		oCol := oTB:getcolumn(i)
		fwrite(nhandle,SP4+'oCol := TBcolumnNew("'+oCol:heading+'",fieldblock("'+oCol:cargo+'"))'+CRLF)
		fwrite(nhandle,SP4+'oTB:addcolumn(oCol)'+CRLF)
	next
	fwrite(nhandle,CRLF)

	fwrite(nhandle,SP4+'@ '+alltrim(str(browInfo[TOP]))+','+ ;
									alltrim(str(browInfo[LEFT]))+' to '+ ;
									alltrim(str(browInfo[BOTTOM]))+','+ ;
									alltrim(str(browInfo[RIGHT]))+' DOUBLE '+CRLF)
	fwrite(nhandle,SP4+'@ '+alltrim(str(browInfo[TOP]))+','+ ;
							alltrim(str(browInfo[LEFT]))+'+1 SAY "['+ ;
							alltrim(browInfo[HEAD])+']"'+CRLF)
	fwrite(nhandle,CRLF)

	fwrite(nhandle,SP4+'oTB:gotop()'+CRLF)
	fwrite(nhandle,CRLF)
	
	fwrite(nhandle,SP4+'do while !(nKey==K_ESC)'+CRLF)
	fwrite(nhandle,SP4+SP4+'dispbegin()'+CRLF)
	fwrite(nhandle,SP4+SP4+'do while (nKey := inkey()) == 0 .and. !oTB:stabilize()'+CRLF)
	fwrite(nhandle,SP4+SP4+'enddo'+CRLF)
	fwrite(nhandle,SP4+SP4+'dispend()'+CRLF)
	fwrite(nhandle,SP4+SP4+'if oTB:stable'+CRLF)
	fwrite(nhandle,SP4+SP4+SP4+'nkey := inkey(0)'+CRLF)
	fwrite(nhandle,SP4+SP4+'endif'+CRLF)
	fwrite(nhandle,SP4+SP4+'appKey(nKey,oTB)'+CRLF)
	fwrite(nhandle,SP4+'enddo'+CRLF)
							

	if lOpenDB
		fwrite(nhandle,SP4+'use '+CRLF)
		fwrite(nhandle,CRLF)
	else
		fwrite(nhandle,SP4+'// database is close in main program'+CRLF) 
	endif

	fwrite(nhandle,SP4+'set(_SET_SCOREBOARD,oldscore)'+CRLF)
	fwrite(nhandle,SP4+'setcursor(oldcur)'+CRLF)
	fwrite(nhandle,SP4+'set(_SET_EXACT,oldexact)'+CRLF)
	if lsavescr
		fwrite(nhandle,SP4+'restscreen('+alltrim(str(browInfo[TOP]))+','+ ;
									 alltrim(str(browInfo[LEFT]))+','+ ;
									 alltrim(str(browInfo[BOTTOM]))+','+ ;
									 alltrim(str(browInfo[RIGHT]))+',oldscr)'+CRLF)
	endif

	fwrite(nhandle,'return'+CRLF)
	fwrite(nhandle,CRLF)

return

static procedure saveCfg(oTB,cFile)
	local nhandle 
	local ntot := len(browInfo)
	local i
	local oCol
	local tmpLine
	
	nhandle := fcreate(cFile+".ZZZ")
	fwrite(nhandle,'[BROWSE DESKTOP]'+CRLF)
	ntot := len(browInfo)
	for i := 1 to ntot
		do case
			case ischaracter(browinfo[i])
				fwrite(nhandle,browInfo[i]+CRLF)
			case isnumber(browinfo[i])
				fwrite(nhandle,alltrim(str(browinfo[i]))+CRLF)
		end case
	next
	if empty(othidx)
		fwrite(nhandle,CRLF)
	else
		for i:=1 to len(othIdx)
			if i == len(othIdx)
				fwrite(nhandle,othidx[i]+CRLF)
			else
				fwrite(nhandle,othidx[i]+',')
			endif
		next
	endif
	fwrite(nhandle,'[COLUMN INFO]'+CRLF)
	for i:=1 to oTB:colcount
		oCol := oTB:getcolumn(i)
		tmpLine := padr(oCol:heading,50)
		tmpLine += padr(oCol:cargo,10)
		if isnil(oCol:width)
			tmpLine += '-1   '
		else
			tmpLine += padr(alltrim(str(oCol:width)),5)
		endif
		fwrite(nhandle,tmpLine+CRLF)
	next        
	fwrite(nhandle,'[KEY]'+CRLF)
	for i:=1 to len(akey)
		fwrite(nhandle,aKey[i,1]+aKey[i,2]+CRLF)
	next
	fwrite(nhandle,'[USER ROUTINES]'+CRLF)

	fclose(nhandle)
	
	freshborder()
	oTB:refreshall()
return

static procedure editProc(oTB)
	@ 5,0 clear to 23,79

	readinsert(true)
	cProc := memoedit(cProc,5,0,23,79,true,,132,4,1,0,0,0)

	freshborder()
	oTB:refreshall()
return

